#include "main.h"
#include "joystick.h"

int endgame=0,MouseX,MouseY,MissilesCreated=0,NewMissile=10000,WaveNum=0,
    NewCity=0,CityNum,pause=0;
Uint32 Now,TimeStart,FrameCount=0;
double Speed,FramesPerSecond;
char text[200];

void AddScore(int ScoreBonus)
{
    SDL_Rect rect;
    
    Score+=ScoreBonus*(WaveNum/2+1);
    sprintf(text, "Score: %d", Score);
    rect.x=0;
    rect.y=0;
    rect.w=SFont_TextWidth(text)+30*0.4;
    rect.h=Font->h;
    SDL_SetAlpha(BackPic,(SDL_SRCALPHA), 255);
    SDL_BlitSurface(BackPic, &rect, Screen, &rect);
    PutString(Screen,0,0,text);
    AddThisRect(rect);
}

void GetSpeed()
{
    FrameCount++;
    FramesPerSecond=FrameCount*(float)1000/(SDL_GetTicks()-TimeStart);
    Speed=SDL_GetTicks()-Now;
    // limit speed to 10ms per frame
    while (Speed<10) {
	SDL_Delay(1);
        Speed=(SDL_GetTicks()-Now);
    }
    Now=SDL_GetTicks();
}

void Pause(const SDL_Event *event)
{
    SDL_Event Epause;;
    pause=1;    

    XCenteredString(Screen,250*0.4,"Game Paused");
    SDL_Flip(Screen);

    SDL_PollEvent(&Epause);
    while ( Epause.type == SDL_JOYBUTTONDOWN ) {
	SDL_PollEvent(&Epause);
	SDL_Delay(10);    
    }

    // wait
    SDL_PollEvent(&Epause);
    while ( Epause.type != SDL_JOYBUTTONDOWN ) 
    {
	SDL_PollEvent(&Epause);
	SDL_Delay(10);
    }

    Now=SDL_GetTicks();
    pause=0;
    JoystickReset();
}

int QuitConfirm( char *msg )
{
    SDL_Event confirm;
    SDL_Rect dst;
    pause=1;
    int leave=0;

    // clean input queue
    while ( confirm.type == SDL_KEYDOWN || confirm.type == SDL_JOYBUTTONDOWN )
	SDL_PollEvent(&confirm);
	
    // write message to screen
    dst.x=Screen->w/2-SFont_TextWidth(msg)/2-14;
    dst.y=250*0.4 - 14;
    dst.w=SFont_TextWidth(msg)+28;
    dst.h=38;
    // Green Border
    SDL_FillRect(Screen,&dst,SDL_MapRGB(Screen->format,0,140,0));

    dst.x=Screen->w/2-SFont_TextWidth(msg)/2-10;
    dst.y=250*0.4 - 10;
    dst.w=SFont_TextWidth(msg)+20;
    dst.h=30;
    // Black fill
    SDL_FillRect(Screen,&dst,0);
    XCenteredString(Screen,250*0.4,msg);
//    SDL_UpdateRect(Screen,0,0,0,0);
    SDL_Flip(Screen);

    // wait
    while ( !leave ) {
	SDL_PollEvent(&confirm);
        switch (confirm.type) {
	    case SDL_KEYDOWN :  if ( confirm.key.keysym.sym == SDLK_a ) leave=1;
				if ( confirm.key.keysym.sym == SDLK_x ) leave=2;
				break;
	    case SDL_JOYBUTTONDOWN :	
				if ( confirm.button.button == GP2X_BUTTON_A ) leave=1;
				if ( confirm.button.button == GP2X_BUTTON_X ) leave=2;
				break;
	    default:	break;
	}
	if ( sound ) MikMod_Update();
	SDL_Delay(10);
    }

    SDL_UpdateRect(Screen,0,0,0,0);
    Now=SDL_GetTicks();
    pause=0;
    if ( leave==1 ) return 1;
    else return 0;
}

int NormalEvents(const SDL_Event *event)
{
    switch (event->type) {
	case SDL_QUIT:
	    printf("Quit Requested\n");
	    exit(1); // tmp
	    Quit=1;
	break;
	case SDL_KEYDOWN:
	    if ( event->key.keysym.sym == SDLK_ESCAPE )
		Quit=1;
	    if ( (event->key.keysym.sym == SDLK_RETURN) &&
		(event->key.keysym.mod & KMOD_ALT) )
		    SDL_WM_ToggleFullScreen(SDL_GetVideoSurface());
	break;
    }
    
    return 1;
}

void MenuEvents()
{
    SDL_SetEventFilter(NormalEvents);
}

int GameEvents(const SDL_Event *event)
{
    int button=-1;
    Uint8* keys;

    MouseX=JoyPosX;
    MouseY=JoyPosY;

    switch (event->type) {
	case SDL_QUIT:
	    printf("Quit Requested\n");
	    exit(1); // temp
	    Quit=1;
	break;

#ifdef JOYSTICK
        /* JOYAXISMOTION is handled elsewhere. */
        case SDL_JOYBUTTONDOWN:
        	    JoyB[event->button.button]=1;

		    if ( event->button.button == GP2X_BUTTON_START ) {
			printf("Endgame Requested\n");
			endgame=1;
		    }
		    if ( event->button.button == GP2X_BUTTON_SELECT ) {
			printf("Pause Requested\n");
			Pause(event);
		    }
		    if ( event->button.button == GP2X_BUTTON_A && endgame==0 ) {
			CreateShot(MouseX,MouseY,1);
		    }
		    if ( event->button.button == GP2X_BUTTON_X && endgame==0 ) {
			CreateShot(MouseX,MouseY,2);
		    }
		    if ( event->button.button == GP2X_BUTTON_B && endgame==0 ) {
			CreateShot(MouseX,MouseY,3);
		    }
		    if ( event->button.button == GP2X_BUTTON_VOLUP ) {
			increaseVolume();
		    }
		    if ( event->button.button == GP2X_BUTTON_VOLDOWN ) {
			decreaseVolume();
		    }
		break;

        case SDL_JOYBUTTONUP:
		    JoyB[event->button.button]=0;
                break;
#endif /* JOYSTICK */	

	case SDL_KEYDOWN:
	    keys = SDL_GetKeyState(NULL);
    	    if ( event->key.keysym.sym == SDLK_a && endgame==0 ) button=1;
    	    if ( event->key.keysym.sym == SDLK_s && endgame==0 ) button=2;
	    if ( event->key.keysym.sym == SDLK_d && endgame==0 ) button=3;
	    
	    if ( button > 0 ) {
		CreateShot(MouseX,MouseY,button);
	    }
	    
	        if ( event->key.keysym.sym == SDLK_UP ) JoyB[0]=1;
		if ( event->key.keysym.sym == SDLK_DOWN ) JoyB[4]=1;
		if ( event->key.keysym.sym == SDLK_LEFT ) JoyB[2]=1;
		if ( event->key.keysym.sym == SDLK_RIGHT ) JoyB[6]=1;

	    if ( event->key.keysym.sym == SDLK_ESCAPE ) {
		printf("Endgame Requested\n");
		endgame=1;
	    }
            // Fullscreen toggle
	    if ( (event->key.keysym.sym == SDLK_RETURN) &&
		(event->key.keysym.mod & KMOD_ALT) )
		    SDL_WM_ToggleFullScreen(SDL_GetVideoSurface());
	    // Pause
	    if (( ( event->key.keysym.sym == SDLK_PAUSE ) ||
	        ( event->key.keysym.sym == SDLK_p ) ) &&
		( !pause) )
		    Pause(event);
	break;
	
	case SDL_KEYUP:
	    keys = SDL_GetKeyState(NULL);
	    
	        if ( event->key.keysym.sym == SDLK_UP ) JoyB[0]=0;
	        if ( event->key.keysym.sym == SDLK_DOWN ) JoyB[4]=0;
	        if ( event->key.keysym.sym == SDLK_LEFT ) JoyB[2]=0;
	        if ( event->key.keysym.sym == SDLK_RIGHT ) JoyB[6]=0;
	    
	break;

    }    
    return 1;

}

void UndrawCannon(int x, int y)
{
/*
    SDL_Rect rect;
    
    rect.x=x-(int)(Cannon[0]->w/2);
    rect.y=y;
    rect.w=Cannon[0]->w;
    rect.h=Cannon[0]->h;
    SDL_SetAlpha(BackBuffer,(SDL_SRCALPHA),255);
    BlitPart(rect.x,rect.y,BackBuffer,rect);
*/
}

void DrawCannon(int x, int y)
{
    int add=0;
    float deg;

    MouseX=JoyPosX;
    MouseY=JoyPosY;

    deg=atan((float)(MouseY-(y+20))/(float)(MouseX-x));
    if (MouseX<x) {
	add+=20;
    }
    if (MouseY>y+20)
    	Blit(x-(int)(Cannon[0]->w/2),y,Cannon[0+add]);
    else    
	Blit(x-(int)(Cannon[0]->w/2),y,Cannon[add-(int)(deg*0.6366*10)]);
}

void DrawCenteredText(int y, char *text)
{
    SDL_Rect rect;

    rect.x=Screen->w/2-SFont_TextWidth(text)/2;
    rect.y=y;
    rect.w=SFont_TextWidth(text);
    rect.h=Font->h;
//    SDL_SetAlpha(BackBuffer,(SDL_SRCALPHA), 255);
//    SDL_BlitSurface( BackBuffer, &rect, Screen, &rect);
    PutString(Screen,rect.x,rect.y,text);
    AddThisRect(rect);
}

void StartWave()
{

    JoystickReset();
    int i,dummy=0;
    float sc=0.4;
    SDL_BlitSurface(BackPic, NULL, Screen, NULL);
    NewMissile=0;
    MissilesCreated=0;
    // New City?
    for (i=0;i<6;i++)
        if (!CityDestroyed[i]) dummy++;
    i=abrand(0,5);
    if (dummy<6) {
        if ((!NewCity)||(ArcadeMode)) {
    	    while (!CityDestroyed[i])
		i=abrand(0,5);
    	    CityDestroyed[i]=0;
	    if (i<3)
		Blit(70*sc+i*100*sc,490*sc,CityPic);
	    else
		Blit(130*sc+i*100*sc,490*sc,CityPic);
	    PlaySound(CitySound);
	    WaitWithMouse(100);
	    Update();
	    WaitWithMouse(200);
	    NewCity=1;
	}
	else NewCity=0;
    }
    CityNum=0;
    for (i=0;i<6;i++)
        if (!CityDestroyed[i]) CityNum++;
    // Draw Cities
    dummy=0;
    for (i=0;i<3;i++)
	if (CityDestroyed[i])
	    BlitToBB(70*sc+i*100*sc,490*sc,CityHitPic);
	else
	    BlitToBB(70*sc+i*100*sc,490*sc,CityPic);
    dummy=0;
    for (i=0;i<3;i++)
	if (CityDestroyed[i+3])
	    BlitToBB(430*sc+i*100*sc,490*sc,CityHitPic);
	else
	    BlitToBB(430*sc+i*100*sc,490*sc,CityPic);
    // Printf "Staring Wave" message
    AddScore(0);
//    Blit(0,0,BackBuffer);
    sprintf(text,"Starting Wave #%d",WaveNum+1);
    PutString(Screen, 400*sc-SFont_TextWidth(text)/2, 170*sc, text);
    sprintf(text,"Score %d x",WaveNum/2+1);
    PutString(Screen, 400*sc-SFont_TextWidth(text)/2, 220*sc, text);
    DrawCenteredText(370*sc, "Defend Cities");
    for (i=0;i<3;i++) {
	if ( CannonDestroyed[i] ) {
	    ShotNum[i]=3;
	    CannonDestroyed[i]=0;
	} else
	    ShotNum[i]=10;
	DrawShotNum(i);
    }
//    Update();
    SDL_Flip(Screen);
    // Wait 2 seconds
//    WaitWithMouse(2000-1000*ArcadeMode);
    for (i=0; i<2000; i+=100) {
	SDL_Delay(100);
	if ( sound ) MikMod_Update();
    }
//    Blit(0,0,BackBuffer);
    SDL_BlitSurface(BackPic, NULL, Screen, NULL);
    for (i=0;i<3;i++) DrawShotNum(i);
    // Draw Cities
    dummy=0;
    for (i=0;i<3;i++)
	if (CityDestroyed[i])
	    BlitToBB(70*sc+i*100*sc,490*sc,CityHitPic);
	else
	    BlitToBB(70*sc+i*100*sc,490*sc,CityPic);
    dummy=0;
    for (i=0;i<3;i++)
	if (CityDestroyed[i+3])
	    BlitToBB(430*sc+i*100*sc,490*sc,CityHitPic);
	else
	    BlitToBB(430*sc+i*100*sc,490*sc,CityPic);
    SDL_SetEventFilter(GameEvents);
}

void DrawWave()
{
    int i,dummy=0;
    float sc=1;
    sc=0.4;
    Blit(0,0,BackPic);
    AddScore(0);
    CityNum=0;
    for (i=0;i<6;i++)
        if (!CityDestroyed[i]) CityNum++;
    // Draw Cities
    dummy=0;
    for (i=0;i<3;i++)
	if (CityDestroyed[i])
	    BlitToBB(70*sc+i*100*sc,490*sc,CityHitPic);
	else
	    BlitToBB(70*sc+i*100*sc,490*sc,CityPic);
    dummy=0;
    for (i=0;i<3;i++)
	if (CityDestroyed[i+3])
	    BlitToBB(430*sc+i*100*sc,490*sc,CityHitPic);
	else
	    BlitToBB(430*sc+i*100*sc,490*sc,CityPic);
    for (i=0;i<3;i++) DrawShotNum(i);
}

void WaveScoring()
{
    int x,i,i2,OldScore,xw;
    float sc=1;
    SDL_Rect dst, dst2;
    sc=0.4;

//    UndrawMouse();
    SDL_SetEventFilter(NormalEvents);
    DrawCenteredText(140*sc,"Wave Scoring");
    x=Screen->w/2-(ShotNum[0]+ShotNum[1]+ShotNum[2])*4*sc;
//    printf("1: %d\t2: %d\t3: %d\tE: %d\t\n",ShotNum[0],ShotNum[1],ShotNum[2],x);
    OldScore=Score;
    if (!ArcadeMode)
    for (i=0;i<3;i++) {
        while(ShotNum[i]>0) {
	    Blit(x,200*sc,ShotPic);
	    DrawCenteredText(140*sc,"Wave Scoring");
	    x+=8*sc;
	    AddScore(10);
	    DrawShotNum(i);
	    dst.x=0;
	    dst.y=235*sc;
	    dst.w=Screen->w;
	    dst.h=20;
	    SDL_BlitSurface(BackPic,&dst,Screen,&dst);
	    sprintf(text,"  %d  ", Score-OldScore);
	    DrawCenteredText(235*sc, text);
	    SDL_Flip(Screen);
	    for (i2=0; i2<100; i2+=100) {
		SDL_Delay(100);
		if ( sound ) MikMod_Update();
	    }
	    ShotNum[i]--;
	}
	DrawShotNum(i);
    }


    x=Screen->w/2;
    printf("x: %d\n",x);
    xw=0;
    printf("xw: %d\n",xw);
    OldScore=Score;
    for (i=0;i<6;i++) {
	if (!CityDestroyed[i]) xw+=CityPic->w;
	if ( i>0 ) xw+=5;
    }
    printf("xw: %d\n",xw);
    x=x-xw/2;
    for (i=0;i<6;i++)
     if (!CityDestroyed[i]) {
    	    dst2.x=x;
	    dst2.y=285*sc-ArcadeMode*100*sc;
	    dst2.w=CityPic->w;
	    dst2.h=CityPic->h;
	    printf("x: %d\n",x);
	    SDL_BlitSurface(CityPic,NULL,Screen,&dst2);
//	    Blit(x,285*sc-ArcadeMode*100*sc,CityPic);
	    x+=5+CityPic->w;
	    AddScore(80);
	    sprintf(text,"  %d  ", Score-OldScore);
	    dst.x=0;

	if ( !ArcadeMode ) dst.y=380*sc;
	else dst.y=110;
	dst.w=Screen->w;
	dst.h=20;
	SDL_BlitSurface(BackPic,&dst,Screen,&dst);
	DrawCenteredText(380*sc-ArcadeMode*100*sc, text);
     }

/*	SDL_Flip(Screen);
	for (i2=0; i2<100; i2+=100) {
	    SDL_Delay(100);
	    if ( sound ) MikMod_Update();
	}
*/
    SDL_Flip(Screen);
    for (i2=0; i2<2000; i2+=100) {
	SDL_Delay(100);
	if ( sound ) MikMod_Update();
    }
    SDL_BlitSurface(BackPic,NULL,Screen,NULL);
    Now=SDL_GetTicks();
}

void ProcessEvents()
{
    int i,Rand,b;
    float sc=1;
    sc=0.4;

    SDL_PumpEvents();
//    if (HighDetail) UndrawShot2(); else UndrawShot();
/*    UndrawFlyer();
    UndrawMissile();
    UndrawExplosion();
    UndrawBomb();
*/
/*    if (!CannonDestroyed[0]) UndrawCannon(40*sc,510*sc);
    if (!CannonDestroyed[1]) UndrawCannon(400*sc,510*sc);
    if (!CannonDestroyed[2]) UndrawCannon(760*sc,510*sc);
    UndrawMouse();
*/
    HandleMissile();
    if (HighDetail) HandleShot2(); else HandleShot();
    HandleFlyer();
    HandleExplosion(1);
    HandleBomb();
    HandleCursor();
    DrawMissile();
    if (HighDetail) DrawShot2(); else DrawShot();
    DrawBomb();
    DrawFlyer();
    DrawExplosion();
    if (!CannonDestroyed[0]) DrawCannon(40*sc,510*sc);
    if (!CannonDestroyed[1]) DrawCannon(400*sc,510*sc);
    if (!CannonDestroyed[2]) DrawCannon(760*sc,510*sc);
    JoystickMoveGP2X();
    DrawMouse();
    // Are all cities destroyed?
    if (!endgame) {
        endgame=1;
	FastQuit=2;
	for (i=0;i<6;i++)
	    if (CityDestroyed[i]==0)
		 {endgame=0;FastQuit=0;}
    }
    // New Missiles
    if ((NewMissile<0)&&(Wave[WaveNum].MissilesToDestroy>MissilesCreated)) {
	Rand=abrand(0,99);
	if ((Rand<Wave[WaveNum].MirvChance)&&(MissileCount>0)) {
	    i=abrand(0,MissileCount-1);
	    b=0;
	    while ((Split(i))&&(b<100)) {
		i=abrand(0,MissileCount-1);
		b++;
	    }
	} else if (Rand>99-Wave[WaveNum].FlyerChance) {
	    CreateFlyer();
	} else if (Rand>99-Wave[WaveNum].BombChance-Wave[WaveNum].FlyerChance) {
	    CreateBomb();
	} else
        CreateMissile(abrand(100*sc,700*sc),0);
	NewMissile+=Wave[WaveNum].TimeBetweenShots;
	MissilesCreated++;
    }
    NewMissile-=Speed;
    // New Wave

    if (
	(MissilesCreated==Wave[WaveNum].MissilesToDestroy)
	&&(MissileCount==0)
	&&(ExplosionCount==0)
	&&(BombCount==0)
	&&(FlyerCount==0)
	&&(ShotCount==0)
	) {
        WaveScoring();
	WaveNum++;
	StartWave();
    }    
}

void ShowRules()
{
    SDL_Event revent;

    int i;
    float sc=0.4;

    Blit(0,0,BackPic);
    for (i=0;i<6;i++)
	if (i<3)
	    Blit(70*sc+i*100*sc,490*sc,CityPic);
	else
	    Blit(130*sc+i*100*sc,490*sc,CityPic);
    
    XCenteredString(Screen,50*sc,"< Arcade Mode >");
    PutString(Screen,10*sc,160*sc,"-No extra points for remaining shots.");
    PutString(Screen,10*sc,200*sc,"-More cities = faster shot reload.");
    PutString(Screen,10*sc,240*sc,"-One city is regenerated per wave.");
    PutString(Screen,10*sc,280*sc,"-The game is more difficult.");
    XCenteredString(Screen,400*sc,"click to continue");
    SDL_Flip(Screen);

    while ((revent.type!=SDL_KEYDOWN)&&(revent.type!=SDL_MOUSEBUTTONDOWN)&&(revent.type!=SDL_JOYBUTTONDOWN)) {
	SDL_PollEvent(&revent);
	if ( sound ) MikMod_Update();
	GetSpeed();
	SDL_Delay(10);
    }
}

void StartGame()
{
    int i, end;
    float sc=0.4;
    
    InitWaves();
    for (i=0;i<6;i++) CityDestroyed[i]=0;
    for (i=0;i<3;i++) CannonDestroyed[i]=0;
    ShotCount=0;
    MissileCount=0;
    ExplosionCount=0;
    BombCount=0;
    FlyerCount=0;
    WaveNum=StartLevel;
    Score=0;
    NewCity=0;
    MissilesCreated=0;

    if (ArcadeMode) ShowRules();
    SDL_SetEventFilter(GameEvents);
    StartWave();
//    SDL_Flip(Screen);
/*    for (i=0; i<1600; i+=100) {
        SDL_Delay(100);
	if ( sound ) MikMod_Update();
    }
*/
    Now=SDL_GetTicks();
    Flicker=1;endgame=0;end=0;
    while (!Quit && !end && !FastQuit) {
	DrawWave();
        DrawMissile();
        if (HighDetail) DrawShot2(); else DrawShot();
        DrawBomb();
        DrawFlyer();
        DrawExplosion();
        if (!CannonDestroyed[0]) DrawCannon(40*sc,510*sc);
        if (!CannonDestroyed[1]) DrawCannon(400*sc,510*sc);
        if (!CannonDestroyed[2]) DrawCannon(760*sc,510*sc);
        JoystickMoveGP2X();
        DrawMouse();

        FullUpdate();
        GetSpeed();
	SDL_PollEvent(&event);
	ProcessEvents();
	if ( sound ) MikMod_Update();
	if ( FastQuit != 0 ) end=1;
	else if ( endgame ) {
	    if ( QuitConfirm("Quit this round ? (A=Yes/X=No)")  == 1 ) end=1;
	    else endgame=0;
	}
	SDL_Flip(Screen);
    }
    PlaySound(GameoverSound);
    i=0;
    if (!Quit) 
	while (i<2000) {
    	    FullUpdate();
	    DrawWave();
	    if ( sound ) MikMod_Update();
    	    GetSpeed();
	    ProcessEvents();
	    i+=Speed;
	}

    Flicker=0;
    SDL_SetEventFilter(NormalEvents);
}
