#include <SDL.h>
#include "gfx.h"
#include "main.h"
#include "joystick.h"

static SDL_Joystick *joy=NULL;

int JoyX;
int JoyY;
int JoyB[20];
int JoyPosX;
int JoyPosY;

void JoystickInit()
{
    puts("** Init joystick **");
    if ( SDL_Init(SDL_INIT_JOYSTICK ) < 0 ) ComplainAndExit();
    /* XXX: Should check to see how many joysticks there are (if any),
        how many buttons they have, etc. */
    joy = SDL_JoystickOpen(0);
    
    JoyPosX=160;
    JoyPosY=120;
    
    JoystickReset();

}

void JoystickReset()
{
    int i;
    
    for ( i=0; i< 20; i++ )
        JoyB[i]=0;
}


/* Joystick moves the mouse. */
void JoystickMove()
{
        static Uint32 last_tick=0;
        Uint32 tick;
        Sint16 x,y;
        int MouseX, MouseY;

        if(!joy) return;

        x = SDL_JoystickGetAxis(joy, 0);
        y = SDL_JoystickGetAxis(joy, 1);

        SDL_GetMouseState(&MouseX, &MouseY);

        /* Ticks are in milliseconds, JOYSPEED is in pixels per second. */

        tick = SDL_GetTicks();

        SDL_WarpMouse(MouseX + (int)((x/(float)JOYMAX) 
                                    * (JOYSPEED/1000.0 * (tick - last_tick))),
                     MouseY + (int)((y/(float)JOYMAX) 
                                    * (JOYSPEED/1000.0 * (tick - last_tick))));

        last_tick = tick;
}


/* GP2X Joystick moves the mouse. */
void JoystickMoveGP2X()
{
    if ( JoyB[GP2X_BUTTON_UP] == 1 ) JoyPosY-=2;
    else if ( JoyB[GP2X_BUTTON_DOWN] == 1 ) JoyPosY+=2;
    else if ( JoyB[GP2X_BUTTON_LEFT] == 1 ) JoyPosX-=2;
    else if ( JoyB[GP2X_BUTTON_RIGHT] == 1 ) JoyPosX+=2;
    else if ( JoyB[GP2X_BUTTON_UPLEFT] == 1 ) { JoyPosX-=2; JoyPosY-=2; }
    else if ( JoyB[GP2X_BUTTON_UPRIGHT] == 1 ) { JoyPosX+=2; JoyPosY-=2; }
    else if ( JoyB[GP2X_BUTTON_DOWNLEFT] == 1 ) { JoyPosX-=2; JoyPosY+=2; }
    else if ( JoyB[GP2X_BUTTON_DOWNRIGHT] == 1 ) { JoyPosX+=2; JoyPosY+=2; }

    if ( JoyB[GP2X_BUTTON_L] ) JoyPosX=75;
    if ( JoyB[GP2X_BUTTON_R] ) JoyPosX=320-75;
    if ( JoyB[GP2X_BUTTON_Y] ) JoyPosX=160;

    if ( JoyPosX <= 0 ) JoyPosX=0;
    if ( JoyPosX >= Screen->w ) JoyPosX=Screen->w;
    if ( JoyPosY <= 0 ) JoyPosY=0;
    if ( JoyPosY >= Screen->h ) JoyPosY=Screen->h;

    SDL_WarpMouse(JoyPosX,JoyPosY);
}

// return 0 if the button pressed is one of the movement button else 1
int JoyMoveGP2X(int button)
{
    static int pressed=0;
//    printf("button: %d\n",button);
    
    if ( button >=0 && button <= 7 ) {
	pressed=0;
//	printf(" joystick move action\n");
	return 0;
    }
    else {
	if ( pressed== 0 ) {
	    pressed=1;
//	    printf(" joystick button action\n");
	    return 1;
	}
    }
    
    return 0;
}
