/*  Penguin Command: a clone of the famous Missile Command game
    Copyright (C) 2000 Karl Bartel

    This program is free software; you can redistribute it and/or modify        
    it under the terms of the GNU General Public License as published by        
    the Free Software Foundation; either version 2 of the License, or           
    (at your option) any later version.                                         
                                                                                
    This program is distributed in the hope that it will be useful,       
    but WITHOUT ANY WARRANTY; without even the implied warranty of              
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the               
    GNU General Public License for more details.                
                                                                               
    You should have received a copy of the GNU General Public License           
    along with this program; if not, write to the Free Software                 
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA   
                                                                                
    Karl Bartel                                                         
    Cecilienstr. 14                                                    
    12307 Berlin                                                  
    GERMANY
    karlb@gmx.net                                                      
*/                                                                            
#include "main.h"
#include <time.h> /* For seeding rand() */
#include <string.h>
//#ifdef JOYSTICK
#include "joystick.h"
//#endif
#ifndef VERSION
#define VERSION "1.6.?"
#endif

    int fullscreen=1, CityDestroyed[6]={0,0,0,0,0,0},
	CannonDestroyed[3]={0,0,0}, Score=0, HWCursor=0, NoAlpha=0, ArcadeMode=0, MusicVol=30, SoundVol=90,AllVol=70, FastQuit=0;
//images
    SDL_Surface *ShotPic,*CityPic,*BackPic,*CityHitPic,*Cannon[21],*Font,
		*BombPic[10],*CannonHitPic,*TitlePic,*ExplosionPic[21],
		*CursorPic[10],*FlyerPic[16];
//event handling  
    SDL_Event event;
//other
    int Quit=0, Loaded=0, StartLevel=0;
    Uint32 WaitStart=0;
    int LowDetail=0, MediumDetail=0, HighDetail=1;

int Wait( int time_in_ms )
{
    if (WaitStart==0)
	WaitStart=SDL_GetTicks();
    if (WaitStart+time_in_ms <= SDL_GetTicks()) {
	WaitStart=0;
	return 0;
    }
    return 1;
}

void LoadImages()
{
    int i;
    char text[200];

    BackPic = LoadImage("back.jpg",0);
    SDL_FreeSurface(ShotPic);
    ShotPic = LoadImage("shot.png",3);
    CityPic = LoadImage("city.png",4);
    CityHitPic = LoadImage("cityhit.png",4);
    CannonHitPic = LoadImage("cannonhit.png",4);
    for (i=0;i<21;i++) {
	sprintf(text,"cannon%d.png",i+1);
	SDL_FreeSurface(Cannon[i]);
	Cannon[i] = LoadImage(text,3);
    }
    for (i=0;i<10;i++) {
	sprintf(text,"bomb%d.png",i+1);
	SDL_FreeSurface(BombPic[i]);
	BombPic[i] = LoadImage(text,3);
    }
    for (i=0;i<20;i++) {
	sprintf(text,"%dexplo.png",i+1);
	SDL_FreeSurface(ExplosionPic[i]);
	ExplosionPic[i] = LoadImage(text,3);
    }
    for (i=0;i<9;i++) {
	sprintf(text,"%dcursor.png",i+1);
	SDL_FreeSurface(CursorPic[i]);
	CursorPic[i] = LoadImage(text,3);
    }
    CursorPic[9] = CursorPic[0];
    for (i=0;i<16;i++) {
	sprintf(text,"%dflyer.png",i+1);
	SDL_FreeSurface(FlyerPic[i]);
	FlyerPic[i] = LoadImage(text,3);
    }
}

int Button(int x, int y, char *String, int prev, SDL_Surface *Background)
{
    SDL_Rect rect;
    int MouseX,MouseY;
    
    rect.x=x;
    rect.y=y;
    rect.w=SFont_TextWidth(String);
    rect.h=Font->h;

    MouseX=JoyPosX; MouseY=JoyPosY;

    if ((MouseX>x)&&(MouseY>y)
	&&(MouseX<x+SFont_TextWidth(String))
	&&(MouseY<y+Font->h))
    {
	if (prev!=1) {
	    // clear
//	    SDL_SetAlpha(Background,0,0);
//	    SDL_BlitSurface(Background, &rect, Screen, &rect);
	    // draw
	    PutString(Screen, x, y, String);
//	    AddThisRect(rect);
//	    SDL_BlitSurface(Screen, &rect, Background, &rect);
	    PlaySound(ClickSound);
	}
	else {
	    // clear
//	    SDL_SetAlpha(Background,0,0);
//	    SDL_BlitSurface(Background, &rect, Screen, &rect);
	    // draw
	    PutString(Screen, x, y, String);
//	    AddThisRect(rect);
//	    SDL_BlitSurface(Screen, &rect, Background, &rect);
	}
	return 1;
    } else {
	// clear
	SDL_SetAlpha(Background,0,0);
	SDL_BlitSurface(Background, &rect, Screen, &rect);
	// draw
	PutString(Screen, x, y, String);
	AddThisRect(rect);
	// darken
	SDL_SetAlpha(Background,SDL_SRCALPHA,100);
	SDL_BlitSurface(Background, &rect, Screen, &rect);
        SDL_SetAlpha(Background,0,0);
	SDL_BlitSurface(Screen, &rect, BackBuffer, &rect);
    }
    
    return 0;
}


void SetDetail()
{
    if (LowDetail) {
	HWCursor=1;
	NoAlpha=1;
    }
    if (MediumDetail) {
	HWCursor=0;
	NoAlpha=1;
    }
    if (HighDetail) {
	HWCursor=0;
	NoAlpha=0;
    }
}

void ShowHelp()
{
    float sc=0.4;

    float anim=0;
    int unhelp=0;
    SDL_Rect rect;
    SDL_Event WaitEvent;
    char DetailString[100],LevelString[100],text[100];
    int Level=3,SoundV=3,MusicV=3;
	
    ExplosionCount=0;
    JoyMoveGP2X(0);
    
    Blit(0,0,BackPic);
    SDL_Flip(Screen);
    while ( !unhelp ) {
	        SDL_Flip(Screen);
	        Blit(0,0,BackPic);

        	    SDL_PollEvent(&WaitEvent);
		    
			if ( sound ) MikMod_Update();
			
			JoystickMoveGP2X();

			if ( WaitEvent.type==SDL_JOYBUTTONDOWN ) {
			    JoyB[WaitEvent.button.button]=1;
			    if ( WaitEvent.button.button == GP2X_BUTTON_START) unhelp=1;
			    if ( WaitEvent.button.button == GP2X_BUTTON_X) unhelp=1;
			    if ( WaitEvent.button.button == GP2X_BUTTON_CLICK) unhelp=1;
			}
			

			if (WaitEvent.type==SDL_JOYBUTTONUP) {
			    JoyB[WaitEvent.button.button]=0;
			    JoyMoveGP2X(0);
		    	}
	
			if (WaitEvent.type==SDL_KEYDOWN) {
			    if ( WaitEvent.key.keysym.sym == SDLK_UP ) JoyB[0]=1;
			    if ( WaitEvent.key.keysym.sym == SDLK_DOWN ) JoyB[4]=1;
			    if ( WaitEvent.key.keysym.sym == SDLK_LEFT ) JoyB[2]=1;
		    	    if ( WaitEvent.key.keysym.sym == SDLK_RIGHT ) JoyB[6]=1;
			    if ( WaitEvent.key.keysym.sym == SDLK_ESCAPE ) unhelp=1;

			}
			
			if (WaitEvent.type==SDL_KEYUP) {
			    if ( WaitEvent.key.keysym.sym == SDLK_UP ) JoyB[0]=0;
			    if ( WaitEvent.key.keysym.sym == SDLK_DOWN ) JoyB[4]=0;
			    if ( WaitEvent.key.keysym.sym == SDLK_LEFT ) JoyB[2]=0;
			    if ( WaitEvent.key.keysym.sym == SDLK_RIGHT ) JoyB[6]=0;
			}
    
		        XCenteredString(Screen,10*sc,"< Help & Options (X to leave)>");
		        PutString(Screen,20*sc,60*sc,"Objective: Defend cities");
		        PutString(Screen,20*sc,110*sc,"Move: Stick");
		        PutString(Screen,20*sc,150*sc,"        Shoulder,y = cursor teleport");
		        PutString(Screen,20*sc,190*sc,"Fire:  A=left, X=middle, B=right");
		        PutString(Screen,20*sc,240*sc,"Score:");
		        PutString(Screen,150*sc,270*sc,"10    Remaining Shot");
		        PutString(Screen,148*sc,300*sc,"20    Destroyed Missile");
		        PutString(Screen,150*sc,330*sc,"30    Destroyed Smartbomb");
		        PutString(Screen,150*sc,360*sc,"80    Remaining City");
		        Blit(80*sc-ShotPic->w/2,285*sc-ShotPic->h/2,ShotPic);
		        Blit(80*sc-CityPic->w/2,385*sc-CityPic->h/2,CityPic);
		        XCenteredString(Screen,430*sc,"<(A-) Settings (B+)>");

			if ( WaitEvent.type == SDL_JOYBUTTONUP ) JoyMoveGP2X(0);
			if (ExplosionCount<1) CreateExplosion(80*sc,315*sc);
			HandleExplosion(0);
			DrawExplosion();
			// Bomb
			anim+=Speed/100;
			if ((int)anim>=10) anim-=10;
			rect.x=80*sc-BombPic[0]->w/2; rect.y=342*sc-BombPic[0]->h/2;
			rect.w=BombPic[0]->w*sc; rect.h=BombPic[0]->h*sc;
			Blit(rect.x,rect.y,BombPic[(int)anim]);
			AddThisRect(blitrect);
			// detail button
			if (LowDetail) strcpy(DetailString,"Low Detail");
			if (MediumDetail) strcpy(DetailString,"Medium Detail");
			if (HighDetail) strcpy(DetailString,"High Detail");
			//Detail=Button(400-SFont_TextWidth(DetailString)/2,430,DetailString,Detail,Screen);
			// level start button
			sprintf(LevelString,"Starting at Wave %d", StartLevel+1);
			Level=Button(400*sc-SFont_TextWidth(LevelString)/2,470*sc,LevelString,Level,BackPic);
			// sound buttons
			sprintf(text,"Music Volume: %d", md_musicvolume);
			MusicV=Button(Screen->w/2-SFont_TextWidth(text)/2,510*sc,text,MusicV,BackPic);
			sprintf(text,"Sound Volume: %d", md_sndfxvolume);
			SoundV=Button(Screen->w/2-SFont_TextWidth(text)/2,550*sc,text,SoundV,BackPic);
			// display
			GetSpeed();
			DrawMouse();
//			Update();
			SDL_Flip(Screen);
	    
		if (SoundV) {
			if (WaitEvent.type == SDL_JOYBUTTONUP ) JoyMoveGP2X(0);
			if (WaitEvent.type == SDL_JOYBUTTONDOWN ) {
    			    if (WaitEvent.button.button==GP2X_BUTTON_B ) increaseSoundVolume();
			    if (WaitEvent.button.button==GP2X_BUTTON_A ) decreaseSoundVolume();
			}
			if (WaitEvent.type == SDL_KEYDOWN ) {
    			    if (WaitEvent.key.keysym.sym == SDLK_d ) {
				increaseSoundVolume();
			    }

			    if (WaitEvent.key.keysym.sym == SDLK_a ) {
				decreaseSoundVolume();
			    }
			}

		}

		if (MusicV) {
			if (WaitEvent.type == SDL_JOYBUTTONUP ) JoyMoveGP2X(0);
			if (WaitEvent.type == SDL_JOYBUTTONDOWN ) {
		    	    if (WaitEvent.button.button==GP2X_BUTTON_B) increaseMusicVolume();
			    if (WaitEvent.button.button==GP2X_BUTTON_A) decreaseMusicVolume();
			}
			if (WaitEvent.type == SDL_KEYDOWN ) {
    			    if (WaitEvent.key.keysym.sym == SDLK_d ) {
				increaseMusicVolume();
			    }

			    if (WaitEvent.key.keysym.sym == SDLK_a ) {
				decreaseMusicVolume();
			    }
			}
		}

		if (Level) {
			if (WaitEvent.type == SDL_JOYBUTTONUP ) JoyMoveGP2X(0);
			if (WaitEvent.type == SDL_JOYBUTTONDOWN ) {
			    if (WaitEvent.button.button==GP2X_BUTTON_B && StartLevel<30) {
				StartLevel+=5;			    
    				SDL_Delay(100);
			    }
			    if (WaitEvent.button.button==GP2X_BUTTON_A && StartLevel>0) {
				StartLevel-=5;
				SDL_Delay(100);
			    }
			}
			if (WaitEvent.type == SDL_KEYDOWN ) {
			    if ( WaitEvent.key.keysym.sym == SDLK_a && StartLevel>0 ) {
				StartLevel-=5;
				SDL_Delay(100);
			    }
			    if ( WaitEvent.key.keysym.sym == SDLK_d && StartLevel<30 ) {
				StartLevel+=5;
    				SDL_Delay(100);
			    }
			}
		}
//		SDL_Delay(10);
		SDL_Flip(Screen);
    }
    Quit=0;
}

void ShowCredits()
{    
    float sc=1;
    SDL_Event CEvent;
    
#ifdef RES320X240
    sc=0.4;
#endif

    float MusicDown=100*sc;

    BlitToBB(0,0,BackPic);
#ifndef GP2X
    XCenteredString(BackBuffer,10,"<Penguin Command Credits>");
    PutString(BackBuffer,20,60 ,"Code:");
    PutString(BackBuffer,20,90,"- Karl Bartel <karlb@gmx.net>");
    PutString(BackBuffer,20,140,"Graphics:");
    PutString(BackBuffer,20,170,"- Karl Bartel");
    PutString(BackBuffer,20,200,"- Shane Simmons");
    PutString(BackBuffer,20,140+MusicDown,"Music:");
    PutString(BackBuffer,20,170+MusicDown,"- Skaven of the Future Crew");
    PutString(BackBuffer,100,200+MusicDown,"Data Jack");
    PutString(BackBuffer,100,230+MusicDown,"Ice Frontier");
    PutString(BackBuffer,100,260+MusicDown,"Rama Gardens");
    PutString(BackBuffer,20,300+MusicDown,"- Seth Peelle");
    PutString(BackBuffer,100,330+MusicDown,"Penguin Night");
    PutString(BackBuffer,20,370+MusicDown,"GP2X Port:");
    PutString(BackBuffer,20,400+MusicDown,"- Ingo Arndt <scachi@gmx.de>");
    XCenteredString(BackBuffer,560,"http://www.linux-games.com/");
    FadeScreen(1);
#else
    XCenteredString(Screen,10*sc,"<Penguin Command Credits>");
    PutString(Screen,20*sc,60*sc ,"Code:");
    PutString(Screen,20*sc,90*sc,"- Karl Bartel <karlb@gmx.net>");
    PutString(Screen,20*sc,140*sc,"Graphics:");
    PutString(Screen,20*sc,170*sc,"- Karl Bartel");
    PutString(Screen,20*sc,200*sc,"- Shane Simmons");
    PutString(Screen,20*sc,140*sc+MusicDown,"Music:");
    PutString(Screen,20*sc,170*sc+MusicDown,"- Skaven of the Future Crew");
    PutString(Screen,100*sc,200*sc+MusicDown,"Data Jack");
    PutString(Screen,100*sc,230*sc+MusicDown,"Ice Frontier");
    PutString(Screen,100*sc,260*sc+MusicDown,"Rama Gardens");
    PutString(Screen,20*sc,300*sc+MusicDown,"- Seth Peelle");
    PutString(Screen,100*sc,330*sc+MusicDown,"Penguin Night");
    PutString(Screen,20*sc,370*sc+MusicDown,"GP2X Port:");
    PutString(Screen,20*sc,400*sc+MusicDown,"- Ingo Arndt <scachi@gmx.de>");
    XCenteredString(Screen,560*sc,"http://www.linux-games.com/");
    SDL_Flip(Screen);
#endif
    Now=SDL_GetTicks();
    while (SDL_GetMouseState(NULL,NULL)==SDL_BUTTON(1)) {SDL_PollEvent(&CEvent);SDL_Delay(10);}

    while (CEvent.type!=SDL_MOUSEBUTTONDOWN && CEvent.type!=SDL_KEYDOWN) {
    	if ( CEvent.type == SDL_JOYBUTTONDOWN && JoyMoveGP2X(CEvent.button.button)==1 ) break;
	if ( CEvent.type == SDL_JOYBUTTONUP ) JoyMoveGP2X(0);
	SDL_PollEvent(&CEvent);
#ifndef GP2X
	UndrawMouse();
	DrawMouse();
#endif
        GetSpeed();
	Update();
	
	if ( sound ) MikMod_Update();
    }
    printf("left\n");
}

void ShowTitle()
{
    int start=3,help=3,hiscore=3,quit=3,delay=0,credits=3,arcade=3;
    float NewExplosion=0;

    if (!Loaded) {
	printf("** Loading Font **\n");
	Font = LoadImage("abc.png",4);
	printf("** Init Font **\n");
	InitFont( Font );
	//SDL_EventState(SDL_KEYUP, SDL_IGNORE);
	printf("** Loading Images **\n");
	// load...
	LoadImages();
	Loaded=1;
	MenuEvents();
    }
    SDL_SetAlpha(Font, SDL_SRCALPHA, 0);
    ExplosionCount=0;CursorAnim=0;


    // menu
    while (!Quit) {
    
	Blit(0,0,TitlePic);

	if ( sound ) MikMod_Update();

	if (delay) {
	    Blit(0,0,TitlePic);
	    SDL_BlitSurface(TitlePic,NULL,Screen,NULL);
	    while (event.type==SDL_MOUSEBUTTONDOWN||event.type==SDL_KEYDOWN)
		SDL_PollEvent(&event);
	    Now=SDL_GetTicks();
	    start=3;help=3;hiscore=3;quit=3;credits=3;arcade=3;
	}

	hiscore=Button(5,300*0.4,"Hiscores",hiscore,TitlePic);
	start=Button(160-SFont_TextWidth("Normal Game")/2,300*0.4,"Normal Game",start,TitlePic);
	arcade=Button(160-SFont_TextWidth("Arcade Game")/2,340*0.4,"Arcade Game",arcade,TitlePic);
	help=Button(315-SFont_TextWidth("Help&Conf"),300*0.4,"Help&Conf",help,TitlePic);
	credits=Button(315-SFont_TextWidth("Credits"),450*0.4,"Credits",credits,TitlePic);
	quit=Button(5,450*0.4,"Quit",quit,TitlePic);

	// Fancy explosions
	if ((ExplosionCount<10)&&(NewExplosion<0)) {
	    CreateExplosion(abrand(0,319),abrand(0,280*0.4));
	    NewExplosion+=abrand(0,Screen->h)+50*0.4;
	}
	NewExplosion-=Speed;
	HandleExplosion(0);
	DrawExplosion();
	GetSpeed();

	// Explosions end
	delay=0;
	SDL_PollEvent(&event);
        JoystickMoveGP2X();
	if ( event.type==SDL_JOYBUTTONDOWN ) {
	    JoyB[event.button.button]=1;
	    if ( event.button.button == GP2X_BUTTON_VOLUP ) {
		increaseVolume();
	    }
	    if ( event.button.button == GP2X_BUTTON_VOLDOWN ) {
		decreaseVolume();
	    }
	}

	if (event.type==SDL_JOYBUTTONUP) {
	    JoyB[event.button.button]=0;
	    JoyMoveGP2X(0);
	}
	
	if (event.type==SDL_KEYDOWN) {
	    if ( event.key.keysym.sym == SDLK_UP ) JoyB[0]=1;
	    if ( event.key.keysym.sym == SDLK_DOWN ) JoyB[4]=1;
	    if ( event.key.keysym.sym == SDLK_LEFT ) JoyB[2]=1;
	    if ( event.key.keysym.sym == SDLK_RIGHT ) JoyB[6]=1;
	}
	if (event.type==SDL_KEYUP) {
	    if ( event.key.keysym.sym == SDLK_UP ) JoyB[0]=0;
	    if ( event.key.keysym.sym == SDLK_DOWN ) JoyB[4]=0;
	    if ( event.key.keysym.sym == SDLK_LEFT ) JoyB[2]=0;
	    if ( event.key.keysym.sym == SDLK_RIGHT ) JoyB[6]=0;
	}
	
	if (event.type==SDL_MOUSEBUTTONDOWN
	|| (event.type==SDL_JOYBUTTONDOWN && JoyMoveGP2X(event.button.button)==1 )
	|| ( event.type==SDL_KEYDOWN && event.key.keysym.sym == SDLK_RETURN )
	)
	{
	    if ( event.button.button == GP2X_BUTTON_START ) Quit=1;
	    
	    if (hiscore) {
		JoystickReset();
		ShowHiscore();
		SDL_WaitEvent(&event);
	    }
	    if (start) {
		JoystickReset();
		ArcadeMode=0;
		break;
	    }
	    if (arcade) {
		JoystickReset();
		ArcadeMode=1;
		break;
	    }
	    if (help) {
		JoystickReset();
		ShowHelp();
		SDL_WaitEvent(&event);
	    }
	    if (credits) ShowCredits();
	    if (quit) {
		Quit=1;
		FastQuit=1;
	    }
	    delay=1;
	}
	DrawMouse();
	SDL_Flip(Screen);
    }
    ExplosionCount=0;
//    SDL_WaitEvent(&event);
}

void TextHelp(char *argv[])
{
    printf("\nPenguin Command Version %s\n",VERSION);
    puts("The newest version can be obtained at http://www.linux-games.com/\n");
    printf("Usage: %s [options]\n",argv[0]);
    puts("  [-f, --fullscreen]         start in fullscreen mode (default)");
    puts("  [-w, --windowed]           start in windowed mode");
    puts("  [-s, --nosound]            start without sound");
    puts("  [-l, --lefthandedmouse]    swaps left and right mouse buttons");
    puts("  [-h, --help]               this text\n");

    exit(0);
}

void ReadCommandLine(char *argv[])
{
    int i;
    for ( i=1;argv[i];i++ ) {
	if ((strcmp(argv[i],"--fullscreen")==0)||(strcmp(argv[i],"-f")==0)) fullscreen=1; else
	if ((strcmp(argv[i],"--windowed")==0)||(strcmp(argv[i],"-w")==0)) fullscreen=0; else
	if ((strcmp(argv[i],"--nosound")==0)||(strcmp(argv[i],"-s")==0)) sound=0; else
	if ((strcmp(argv[i],"--lefthandedmouse")==0)||(strcmp(argv[i],"-l")==0)) LeftHandedMouse=1; else
	if ((strcmp(argv[i],"--help")==0)||(strcmp(argv[i],"-h")==0)) TextHelp(argv);
	else {
	    printf("\nUnknown parameter: \"%s\" \n", argv[i]);
	    TextHelp(argv);
	}
    }
}

int main(int argc, char *argv[])
{
// intialisation
    int RQuit=0;
//    if ( SDL_Init(SDL_INIT_AUDIO ) < 0 ) ComplainAndExit();
    ReadCommandLine(argv);
    printf("** Starting SDL init **\n");
    init_SDL();
    SDL_EventState(SDL_ACTIVEEVENT, SDL_IGNORE);
#ifndef GP2X
    SDL_WM_SetCaption("Penguin Command","Penguin Command");
#endif
    srand((unsigned)time(NULL));
//#ifdef JOYSTICK
/* joystick */
    printf("** Finding Joysticks **\n");
    JoystickInit();
//#endif
// load data
    printf("** Loading Title Screen **\n");
    TitlePic = LoadImage("title.jpg",0);
    InitSound();
    ReadOptions();
// show title screen
    SDL_EnableUNICODE(1);
    SDL_ShowCursor(0);
    printf("** Ready to enter Menu **\n");
//    if ( sound ) {
	PlayMusic();
	md_musicvolume=MusicVol;
	md_sndfxvolume=SoundVol;
	md_volume=AllVol;
//    }
    while (!RQuit) {
#ifdef USE_SOUND
		if (sound) {
			printf("** Fade in Music **\n");
			//Mix_FadeInMusic(Music[abrand(0,MUSICNUM-1)],0,5000);
		}
#endif
		printf("** Showing Title Screen **\n");
		JoystickReset();
		ShowTitle();
		if (FastQuit==1) {
		    RQuit=1;
		    continue;
		}
		else if (FastQuit==2) {
		    FastQuit=0;
		    Quit=0;
		    RQuit=0;
		    continue;
		}
		else if (Quit && FastQuit==0) {
		    if ( QuitConfirm("Quit ? (A=Yes/X=No)") == 1 ) {
			RQuit=1;
			break;
		    } else {
			Quit=0;
			continue;
		    }
		}
		StartGame();
		JoystickReset();
		FinalScore();
		JoystickReset();
		ShowHiscore();
    }
// user wants to quit
#ifdef USE_SOUND
//    Mix_FadeOutMusic(1000);
    Player_SetVolume (0);
#endif
#ifndef RES320X240
    {SDL_Rect rect; rect.x=0;rect.y=0;rect.w=Screen->w;rect.h=Screen->h; SDL_FillRect(BackBuffer,&rect,0);}
#else
    {SDL_Rect rect; rect.x=0;rect.y=0;rect.w=Screen->w;rect.h=Screen->h; SDL_FillRect(Screen,&rect,0);}
#endif
    FadeScreen(0.9);
    WriteOptions();
//    printf("Awaiting SDL_Quit()\n");
    if ( sound ) closeAudio();
    SDL_Quit();
//    printf("SDL_Quit() finished.\n");
    return 0;
}
