#include "main.h"
#include "joystick.h"
#include <errno.h>
#include <string.h>

char Player[10][200];
int Hiscore[10];

FILE *OpenOptionsFile( char *mode )
{
    char filename[200];
    FILE *file;
    
    sprintf( filename, "./.penguin-command");

    file = fopen(filename, mode);
    
    if (file==NULL) {
	fprintf(stderr, "\nWarning: I could not open the options file ");
	if (strcmp(mode, "r") == 0)
	    fprintf(stderr, "for read:");
	else if (strcmp(mode, "w") == 0)
	    fprintf(stderr, "for write:");

	fprintf(stderr, "\n%s\n"
	    "The error that occured was:\n"
	    "%s\n\n", filename, strerror(errno));
    }
    
    return file;
}

void WriteOptions()
{
    FILE *file;
    int i;

    file=OpenOptionsFile("w");
    if (file==NULL) exit(1);
    
    fprintf(file, "# Penguin Command Options File\n\n");
    for (i=0;i<10;i++)
	fprintf(file, "%s\n", Player[i]);
    for (i=0;i<10;i++)
	fprintf(file, "%d\n", Hiscore[i]);
    fprintf(file, "%d\n",LowDetail);
    fprintf(file, "%d\n",MediumDetail);
    fprintf(file, "%d\n",HighDetail);
    fprintf(file, "%d\n",md_musicvolume);
    fprintf(file, "%d\n",md_sndfxvolume);
    fprintf(file, "%d\n",md_volume);

    fclose(file);
}

void ReadOptions()
{
    FILE *file;
    int i;
        
    file=OpenOptionsFile("r");
    
    if (file==NULL) {
	file=OpenOptionsFile("w");
	if (file==NULL) exit(1);
	
	fprintf(file, "# Penguin Command Options File\n\n");
	fprintf(file, "Sam\nLion\nTux\nThue\nTesmako\nChristian\nAkawaka\nDust Puppy\nMichael\nAndreas\n");
	for (i=0;i<10;i++)
	    fprintf(file, "%d\n", 5000-i*500);
	
	fclose(file);
	file=OpenOptionsFile("r");
    }

    fscanf(file, "%*s%*s%*s%*s%*s\n");
    for (i=0;i<10;i++)
	fscanf(file, "%[^\n]\n",Player[i]);
    for (i=0;i<10;i++)
	fscanf(file, "%d\n",&Hiscore[i]);
    if   ((fscanf(file, "%d\n",&LowDetail)==EOF)
	||(fscanf(file, "%d\n",&MediumDetail)==EOF)
	||(fscanf(file, "%d\n",&HighDetail)==EOF)
	||(fscanf(file, "%d\n",&MusicVol)==EOF)
	||(fscanf(file, "%d\n",&SoundVol)==EOF)
	||(fscanf(file, "%d\n",&AllVol)==EOF))
	WriteOptions();
//    for (i=0;i<10;i++)
//	printf("%s %d\n",Player[i],Hiscore[i]);
    
    fclose(file);
}

void FinalScore()
{
    int i;
    int done=0;
    SDL_Event input;

    if (Score>Hiscore[9]) {

    char Name[200]="",text[200];
    char test[200];
    int a;
/*
    Blit(0,0,BackPic);
    PutString(Screen,400-SFont_TextWidth("Final Score")/2,200,"Final Score");
    sprintf(text,"%d", Score);
    PutString(Screen,400-SFont_TextWidth(text)/2,250,text);
    PutString(Screen,400-SFont_TextWidth("Enter Your Name:")/2,300,"Enter Your Name:");
    Update();
*/
    int pos=0;
    int posx;
    posx=60*0.4;
    float delay=0;
    while ( !done ) {
	Blit(0,0,BackPic);
        PutString(Screen,5,5,"Stick up/down");
	PutString(Screen,145,5,"= choose letter");
	PutString(Screen,5,18,"Stick right");
	PutString(Screen,145,18,"= next letter");
	PutString(Screen,5,31,"Left shoulder");
	PutString(Screen,145,31,"= delete last letter");
	PutString(Screen,5,44,"Button A,B,Y,X,..");
	PutString(Screen,145,44,"= save this name");
        PutString(Screen,400*0.4-SFont_TextWidth("Final Score")/2,200*0.4,"Final Score");
        sprintf(text,"%d", Score);
        PutString(Screen,400*0.4-SFont_TextWidth(text)/2,250*0.4,text);
        PutString(Screen,400*0.4-SFont_TextWidth("Enter Your Name:")/2,300*0.4,"Enter Your Name:");
	// starting with an "A"
	if ( pos == 0 && strcmp(Name,"") == 0 ) {
	    PutString(Screen,posx,350*0.4,"A");
	    snprintf(Name,sizeof(Name),"A");
	} else PutString(Screen,posx,350*0.4,Name);

	SDL_PollEvent(&input);
	switch ( input.type ) {
	    case SDL_KEYDOWN :	if ( delay==0 ) delay=SDL_GetTicks();
				if ( delay+200 > SDL_GetTicks() ) break;
				else delay=0;
				if ( input.key.keysym.sym == SDLK_RETURN ) done=1;
				if ( input.key.keysym.sym == SDLK_ESCAPE ) exit(1);
				if ( input.key.keysym.sym == SDLK_UP ) {
				  if ( Name[pos] >=65 && Name[pos] <90 ) Name[pos]=Name[pos]+1;
				  else if ( Name[pos] == 90 ) Name[pos] = 65;
				}
				if ( input.key.keysym.sym == SDLK_DOWN ) {
				  if ( Name[pos] >65 && Name[pos] <=90 ) Name[pos]=Name[pos]-1;
				  else if ( Name[pos] == 65 ) Name[pos] = 90; 
				}
				if ( input.key.keysym.sym == SDLK_RIGHT && pos < 16 ) {
				    pos++;
				    if ( Name[pos]=='\0' ) {
					Name[pos]='A';
					Name[pos+1]='\0';
				    }
				}
				if ( input.key.keysym.sym == SDLK_LEFT && pos > 0 ) {
				    pos--;
				}
				if ( input.key.keysym.sym == SDLK_BACKSPACE && pos > 0 ) {
				    Name[pos]='\0';
				    pos--;
				}
				break;

	    case SDL_JOYBUTTONDOWN :
				if ( delay==0 ) delay=SDL_GetTicks();
				if ( delay+200 > SDL_GetTicks() ) break;
				else delay=0;
				if ( input.button.button == GP2X_BUTTON_START ) done=1;
				if ( input.button.button == GP2X_BUTTON_SELECT ) done=1;
				if ( input.button.button == GP2X_BUTTON_CLICK ) done=1;
				if ( input.button.button == GP2X_BUTTON_A ) done=1;
				if ( input.button.button == GP2X_BUTTON_B ) done=1;
				if ( input.button.button == GP2X_BUTTON_X ) done=1;
				if ( input.button.button == GP2X_BUTTON_Y ) done=1;
				if ( input.button.button == GP2X_BUTTON_UP ) {
				  if ( Name[pos] >=65 && Name[pos] <90 ) Name[pos]=Name[pos]+1;
				  else if ( Name[pos] == 90 ) Name[pos] = 65;
				}
				if ( input.button.button == GP2X_BUTTON_DOWN ) {
				  if ( Name[pos] >65 && Name[pos] <=90 ) Name[pos]=Name[pos]-1;
				  else if ( Name[pos] == 65 ) Name[pos] = 90; 
				}
				if ( input.button.button == GP2X_BUTTON_RIGHT && pos < 16 ) {
				    pos++;
				    if ( Name[pos]=='\0' ) {
					Name[pos]='A';
					Name[pos+1]='\0';
				    }
				}
				if ( input.button.button == GP2X_BUTTON_LEFT && pos > 0 ) {
				    pos--;
				}
				if ( input.button.button == GP2X_BUTTON_L && pos > 0 ) {
				    Name[pos]='\0';
				    pos--;
				}
				break;
	    default : break;
	
	}
	// mark the cursor position
	snprintf(test,pos+1,Name);
	PutString(Screen,posx+SFont_TextWidth(test),350*0.4,"_");
	SDL_Flip(Screen);
	SDL_Delay(10);
	if ( sound ) MikMod_Update();
	
    }
    if ( strcmp(Name,"A") == 0 ) strcpy(Name,"Anonym. Coward");
    else {
	for ( i=1;i<strlen(Name);i++) {
	    Name[i]=tolower(Name[i]);
	}
        printf("Name: %s\n",Name);
    }
    for (i=0;i<10;i++) {
	if (Score>Hiscore[i]) {
	    // Move other players down on the list
	    for (a=9;a>=i;a--) {
		strcpy(Player[a],Player[a-1]);
		Hiscore[a]=Hiscore[a-1];		
	    }
	    // add the player
	    strcpy(Player[i],Name);
	    Hiscore[i]=Score;
	    break;
	}
    }
//    for (i=0;i<10;i++)
//	printf("%s %d\n",Player[i],Hiscore[i]);
    
    WriteOptions();
    }
}

void ShowHiscore()
{
    char text[200];
    int i;
    SDL_Event WaitEvent;

    BlitToBB(0,0,BackPic);
    PutString(Screen,400*0.4-SFont_TextWidth("<Penguin Command Hiscores>")/2,70*0.4,"<Penguin Command Hiscores>");
    for (i=0;i<10;i++) {
	sprintf(text,"%s", Player[i]);
	PutString(Screen,120*0.4,150*0.4+i*30*0.4,text);
	sprintf(text,"%d", Hiscore[i]);
	PutString(Screen,640*0.4-SFont_TextWidth(text),150*0.4+i*30*0.4,text);
    }
    SDL_Flip(Screen);

    while ((WaitEvent.type!=SDL_KEYDOWN)&&(WaitEvent.type!=SDL_MOUSEBUTTONDOWN)) {
    	if ( WaitEvent.type == SDL_JOYBUTTONDOWN && JoyMoveGP2X(WaitEvent.button.button)==1 ) break;
	if ( WaitEvent.type == SDL_JOYBUTTONUP ) JoyMoveGP2X(0);
	SDL_PollEvent(&WaitEvent);
	SDL_Delay(10);
	if ( sound ) MikMod_Update();
    }
    Now=SDL_GetTicks();                          
}
